<?php
/*
	+----------------------------------------------------------------------+
	|	Ultimate SEO URLs For Zen Cart, version 2.200                        |
	+----------------------------------------------------------------------+
	|                                                                      |
	|	Derrived from Ultimate SEO URLs v2.1 for osCommerce by Chemo         |
	|                                                                      |
	|	Portions Copyright 2012, Andrew Ballanger                              |
	|                                                                      |
	|	Portions Copyright 2012, JardaR                              |
	|                                                                      |
	|	Portions Copyright 2005, Joshua Dechant                              |
	|                                                                      |
	|	Portions Copyright 2005, Bobby Easland                               |
	|                                                                      |
	|	Portions Copyright 2003 The zen-cart developers                      |
	|                                                                      |
	+----------------------------------------------------------------------+
	| This source file is subject to version 2.0 of the GPL license,       |
	| that is bundled with this package in the file LICENSE, and is        |
	| available through the world-wide-web at the following url:           |
	| http://www.zen-cart.com/license/2_0.txt.                             |
	| If you did not receive a copy of the zen-cart license and are unable |
	| to obtain it through the world-wide-web, please send a note to       |
	| license@zen-cart.com so we can mail you a copy immediately.          |
	+----------------------------------------------------------------------+
*/

	class SEO_URL_INSTALLER{
		var $default_config;
		var $db;
		var $attributes;

		function SEO_URL_INSTALLER() {
			$this->attributes = array();

			$x = 0;
			$this->default_config = array();

			$this->default_config['SEO_ENABLED'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Povolit SEO adresy?', 'SEO_ENABLED', 'true', 'Povolit SEO adresy? JednÃ¡ se o globÃ¡nÃ­ nastavenÃ­ a urcuje zda povolit nebo zakÃ¡zat pouÅ¾Ã­vÃ¡nÃ­ SEO adres', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['SEO_ADD_CPATH_TO_PRODUCT_URLS'] = array(
				'DEFAULT' => 'false',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Pridat cPath do URL zboÅ¾Ã­?', 'SEO_ADD_CPATH_TO_PRODUCT_URLS', 'false', 'NastavenÃ­ pridÃ¡ cPath na konec URL zboÅ¾Ã­ (napr. - nejake-zbozi-p-1.html?cPath=xx).', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['SEO_ADD_CAT_PARENT'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'VloÅ¾it na zacÃ¡tek URL adresy materskou kategorii?', 'SEO_ADD_CAT_PARENT', 'true', 'NastavenÃ­ pridÃ¡ na zacÃ¡tek URL cesty nÃ¡zev materskÃ© kategorie (napr. - materska-kategorie-c-1.html).', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			/* START SEO-ADD-PRODUCT-CAT PATCH
			*
			* Patched to use SEO_ADD_PRODUCT_CAT
			* This allows the use of a directory structure for urls.
			* @author Andrew Ballanger
			*/
			$this->default_config['SEO_ADD_PRODUCT_CAT'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Zobrazit kategorie jako adresare v URL?', 'SEO_ADD_PRODUCT_CAT', 'true', 'Toto nastavení se přidat název kategorie na začátek výrobku URL jako adresářů. (category-c-1/product-p-1.html).', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;
			// END SEO-ADD-PRODUCT-CAT PATCH

			$this->default_config['SEO_URLS_FILTER_SHORT_WORDS'] = array(
				'DEFAULT' => '0',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'FiltrovÃ¡nÃ­ krÃ¡tkÃ½ch slov', 'SEO_URLS_FILTER_SHORT_WORDS', '0', 'NastavenÃ­ bude filtrovat z URL adresy slova kratÅ¡Ã­ nebo stejnÃ© dÃ©lky jako je zadanÃ¡ hodnota.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, NULL)"
			);
			$x++;

			$this->default_config['SEO_URLS_USE_W3C_VALID'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'VÃ½stup W3C platnÃ© URL adresy (parametr retezec)?', 'SEO_URLS_USE_W3C_VALID', 'true', 'NastavenÃ­m zÃ­skÃ¡te W3C platnÃ© URL adresy.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['USE_SEO_CACHE_GLOBAL'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Povolit SEO mezipamet pro uloÅ¾enÃ­ dotazu?', 'USE_SEO_CACHE_GLOBAL', 'true', 'JednÃ¡ se o globÃ¡lnÃ­ nastavenÃ­ a urcuje zda povolit nebo zakÃ¡zat pouÅ¾Ã­vÃ¡nÃ­ mezipameti.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['USE_SEO_CACHE_PRODUCTS'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Povolit mezipamet pro zboÅ¾Ã­?', 'USE_SEO_CACHE_PRODUCTS', 'true', 'PrepÃ­nÃ¡ pouÅ¾Ã­vÃ¡nÃ­ mezipameti pro zboÅ¾Ã­.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
				);
			$x++;

			$this->default_config['USE_SEO_CACHE_CATEGORIES'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Povolit mezipamet pro kategorie?', 'USE_SEO_CACHE_CATEGORIES', 'true', 'PrepÃ­nÃ¡ pouÅ¾Ã­vÃ¡nÃ­ mezipameti pro kategorie.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['USE_SEO_CACHE_MANUFACTURERS'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Povolit mezipamet pro vÃ½robce/dodavatele?', 'USE_SEO_CACHE_MANUFACTURERS', 'true', 'PrepÃ­nÃ¡ pouÅ¾Ã­vÃ¡nÃ­ mezipameti pro vÃ½robce/dodavatele.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['USE_SEO_CACHE_ARTICLES'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Povolit mezipamet pro clÃ¡nky?', 'USE_SEO_CACHE_ARTICLES', 'true', 'PrepÃ­nÃ¡ pouÅ¾Ã­vÃ¡nÃ­ mezipameti pro clÃ¡nky.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['USE_SEO_CACHE_INFO_PAGES'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Povolit mezipamet pro informacnÃ­ strÃ¡nky?', 'USE_SEO_CACHE_INFO_PAGES', 'true', 'PrepÃ­nÃ¡ pouÅ¾Ã­vÃ¡nÃ­ mezipameti pro informacnÃ­ strÃ¡nky.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['USE_SEO_REDIRECT'] = array(
				'DEFAULT' => 'true',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Povolit automatickÃ¡ presmerovÃ¡nÃ­?', 'USE_SEO_REDIRECT', 'true', 'Aktivuje kÃ³d automatickÃ©ho presmerovÃ¡nÃ­ a odeÅ¡le 301 hlavicky na novÃ© URL adresy.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			$this->default_config['SEO_REWRITE_TYPE'] = array(
				'DEFAULT' => 'Rewrite',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Zpusob prepisu URL adresy', 'SEO_REWRITE_TYPE', 'Rewrite', 'Zvolte formÃ¡t prepisu SEO url adres.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''Rewrite''),')"
			);
			$x++;

			$this->default_config['SEO_CHAR_CONVERT_SET'] = array(
				'DEFAULT' => '',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Konverze speciÃ¡lnÃ­ch znaku', 'SEO_CHAR_CONVERT_SET', 'Ã¤=>ae,Ã«=>ie,Ã¶=>oe,Ã¼=>ue,Ã„=>AE,Ã‹=>IE,Ã–=>OE,Ãœ=>UE, Ã¡=>a,c=>c,d=>d,Ã©=>e,e=>e,Ã­=>i,l=>l,n=>n, Ã³=>o,Ã´=>o, r=>r,r=>r,Å¡=>s,t=>t,Ãº=>u,u=>u,Ã½=>y,Å¾=>z,Ã�=>A,C=>C, D=>D,Ã‰=>E,E=>E,Ã�=>I,L=>L,N=>N,Ã“=>O,Ã”=>O,R=>R, R=>R,Å =>S,T=>T,Ãš=>U,U=>U,Ã�=>Y,Å½=>Z', 'NastavenÃ­ konvertuje speciÃ¡lnÃ­ znaky.<br><br>FormÃ¡t <b>MUSÃ�</b> bÃ½t tento: <b>char=>conv,char2=>conv2</b>', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, NULL)"
			);
			$x++;

			$this->default_config['SEO_REMOVE_ALL_SPEC_CHARS'] = array(
				'DEFAULT' => 'false',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Odstranit vÅ¡echny nealfanumerickÃ© znaky?', 'SEO_REMOVE_ALL_SPEC_CHARS', 'false', 'OdstranÃ­ vÅ¡echny znaky krome pÃ­smen a cÃ­sel. Mohou se tÃ­m vhodne odstranit vÅ¡echny speciÃ¡lnÃ­ znaky z predchozÃ­ho nastavenÃ­.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, 'zen_cfg_select_option(array(''true'', ''false''),')"
			);
			$x++;

			// START SEO-URLS-FILTER-PCRE PATCH
			$this->default_config['SEO_URLS_FILTER_PCRE'] = array(
				'DEFAULT' => '',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Zadejte PCRE filtru pravidla pro generovanÃ© URL', 'SEO_URLS_FILTER_PCRE', '', 'Toto nastavenÃ­ pouÅ¾Ã­vÃ¡ PCRE pravidla pro filtrovÃ¡nÃ­ URL generovanÃ©.<br><br>FormÃ¡t <b>musÃ­ bÃ½t</b> ve tvaru: <b>najÃ­t1=>nahradit1,najÃ­t2=>nahradit2</b>. Tento filtr je beÅ¾et pred znaku konverzÃ­ a odizolovÃ¡nÃ­ speciÃ¡lnÃ­ch znaku. Pokud chcete Dash - v adresÃ¡ch URL, pouÅ¾ijte jednu mezeru. TakÃ© si vÅ¡imnete, musÃ­te dvakrÃ¡t uniknout zpet lomÃ­tka.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, NULL)"
			);
			$x++;
			// END SEO-URLS-FILTER-PCRE PATCH

			$this->default_config['SEO_URLS_CACHE_RESET'] = array(
				'DEFAULT' => 'false',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'Resetovat mezipamet SEO URL adres', 'SEO_URLS_CACHE_RESET', 'false', 'Resetuje mezipamet pro SEO data. VhodnÃ© pri velkÃ½ch zmenÃ¡ch a aktualizacÃ­ch zboÅ¾Ã­.', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), 'zen_reset_cache_data_seo_urls', 'zen_cfg_select_option(array(''reset'', ''false''),')"
			);
			$x++;

			//IMAGINADW.COM
			$this->default_config['SEO_URLS_ONLY_IN'] = array(
				'DEFAULT' => 'index, product_info, products_new, products_all, featured_products, specials, contact_us, conditions, privacy, reviews, shippinginfo, faqs_all, site_map, gv_faq, discount_coupon, page, page_2, page_3, page_4',
				'QUERY' => "INSERT INTO `".TABLE_CONFIGURATION."` VALUES ('', 'VloÅ¾te strÃ¡nky s prÃ¡vem prepisu', 'SEO_URLS_ONLY_IN', 'index, product_info, products_new, products_all, featured_products, specials, contact_us, conditions, privacy, reviews, shippinginfo, faqs_all, site_map, gv_faq, discount_coupon, page, page_2, page_3, page_4', 'This setting will allow the rewrite only in the specified pages. If it\'s empty all pages will be rewrited. <br><br>The format <b>MUST</b> be in the form: <b>page1,page2,page3</b>', GROUP_INSERT_ID, ".$x.", NOW(), NOW(), NULL, NULL)"
			);
			$x++;

			$this->db = &$GLOBALS['db'];

			$this->init();
		}

/**
 * Initializer - if there are settings not defined the default config will be used and database settings installed.
 * @author Bobby Easland
 * @version 1.1
 */
	function init() {
		foreach( $this->default_config as $key => $value ){
			$container[] = defined($key) ? 'true' : 'false';
		} # end foreach
		$this->attributes['IS_DEFINED'] = in_array('false', $container) ? false : true;
		switch(true){
			case ( !$this->attributes['IS_DEFINED'] ):
				$this->eval_defaults();
				$sql = "SELECT configuration_key, configuration_value
						FROM " . TABLE_CONFIGURATION . "
						WHERE configuration_key LIKE '%SEO%'";
				$result = $this->db->Execute($sql);
				$num_rows = $result->RecordCount();
				$this->attributes['IS_INSTALLED'] = (sizeof($container) == $num_rows) ? true : false;
				if ( !$this->attributes['IS_INSTALLED'] ){
					$this->install_settings();
				}
				break;
			default:
				$this->attributes['IS_INSTALLED'] = true;
				break;
		} # end switch
	} # end function

/**
 * This function evaluates the default settings into defined constants
 * @author Bobby Easland
 * @version 1.0
 */
	function eval_defaults(){
		foreach( $this->default_config as $key => $value ){
			define($key, $value['DEFAULT']);
		} # end foreach
	} # end function

/**
 * This function removes the database settings (configuration and cache)
 * @author Bobby Easland
 * @version 1.0
 */
	function uninstall_settings(){
		$this->db->Execute("DELETE FROM `".TABLE_CONFIGURATION_GROUP."` WHERE `configuration_group_title` LIKE '%SEO%'");
		$this->db->Execute("DELETE FROM `".TABLE_CONFIGURATION."` WHERE `configuration_key` LIKE '%SEO%'");
		/* START SEO-1.5-COMPATIBILITY
		 *
		 * Patched for compatibility with Zen Cart 1.5
		 * @author Andrew Ballanger
		 */
		$this->db->Execute("DELETE FROM `".TABLE_ADMIN_PAGES."` WHERE `page_key`='configUltimateSEO'");
		// END SEO-1.5-COMPATIBILITY

		// Verze 2.200 je oddeli verzi 2.110 a nepouziva stejne klÃ­ce pridat
		// admin stranky jako verze 2.150. Pokud klic pouzivany ve verzi 2.150
		// je pritomen odstranit stary klic, aby se zabranilo moznym problemum
		// pozdeji dolu na silnici.
		$this->db->Execute("DELETE FROM `".TABLE_ADMIN_PAGES."` WHERE `page_key`='UltimateSEO'");

		$this->db->Execute("DROP TABLE IF EXISTS " . TABLE_SEO_CACHE);
	} # end function

/**
 * This function installs the database settings
 * @author Bobby Easland
 * @version 1.0
 */
	function install_settings(){
		$this->uninstall_settings();
		$sort_order_query = "SELECT MAX(sort_order) as max_sort FROM `".TABLE_CONFIGURATION_GROUP."`";
		$next_sort = $this->db->Execute($sort_order_query);
		$next_sort = $next_sort->fields['max_sort'] + 1;
		$insert_group = "INSERT INTO `".TABLE_CONFIGURATION_GROUP."` VALUES ('', 'SEO URLs', 'Options for Ultimate SEO URLs', '".$next_sort."', '1')";
		$this->db->Execute($insert_group);
		$group_id = $this->db->insert_ID();

		/* START SEO-1.5-COMPATIBILITY
		 *
		 * Patched to use SEO_ADD_PRODUCT_CAT
		 * This allows the use of a directory structure for urls.
		 * @author Andrew Ballanger
		 */
		$page_sort_query = "SELECT MAX(sort_order) as max_sort FROM `". TABLE_ADMIN_PAGES ."` WHERE menu_key='configuration'";
		$page_sort = $this->db->Execute($page_sort_query);
		$page_sort = $page_sort->fields['max_sort'] + 1;
		$insert_page = "INSERT INTO `" . TABLE_ADMIN_PAGES . "` VALUES ('configUltimateSEO', 'BOX_CONFIGURATION_ULTIMATE_SEO', 'FILENAME_CONFIGURATION', 'gID=" . $group_id . "', 'configuration', 'Y', '" . $page_sort . "')";
		$this->db->Execute($insert_page);
		// END SEO-1.5-COMPATIBILITY

		foreach ($this->default_config as $key => $value){
			$sql = str_replace('GROUP_INSERT_ID', $group_id, $value['QUERY']);
			$this->db->Execute($sql);
		}

		$insert_cache_table = "CREATE TABLE " . TABLE_SEO_CACHE . " (
		  `cache_id` varchar(32) NOT NULL default '',
		  `cache_language_id` tinyint(1) NOT NULL default '0',
		  `cache_name` varchar(255) NOT NULL default '',
		  `cache_data` mediumtext NOT NULL,
		  `cache_global` tinyint(1) NOT NULL default '1',
		  `cache_gzip` tinyint(1) NOT NULL default '1',
		  `cache_method` varchar(20) NOT NULL default 'RETURN',
		  `cache_date` datetime NOT NULL default '0000-00-00 00:00:00',
		  `cache_expires` datetime NOT NULL default '0000-00-00 00:00:00',
		  PRIMARY KEY  (`cache_id`,`cache_language_id`),
		  KEY `cache_id` (`cache_id`),
		  KEY `cache_language_id` (`cache_language_id`),
		  KEY `cache_global` (`cache_global`)
		) TYPE=MyISAM;";
		$this->db->Execute($insert_cache_table);
	} # end function
} # end class
?>